﻿// --------------------------------------------------------------------------------------------------------------------- 
// <copyright file="IWareHouse.cs" company="Microsoft">
//   IWareHouse
// </copyright>
// <summary>
//   Defines the IWareHouse type.
// </summary>
// ---------------------------------------------------------------------------------------------------------------------
// ==++==
// 
//   Copyright (c) Microsoft Corporation.  All rights reserved.
// 
// ==--==
namespace FabrikamSports
{
    /// <summary>
    /// Interface for WareHouse
    /// </summary>
    public interface IWareHouse
    {
        /// <summary>
        /// Check for Inventory
        /// </summary>
        /// <param name="product">The product.</param>
        /// <param name="quantity">The quantity.</param>
        /// <returns>Returns <see cref="bool"/></returns>
        bool HasInventory(Product product, int quantity);

        /// <summary>
        /// Removes an item from the Invetory
        /// </summary>
        /// <param name="product">The product.</param>
        /// <param name="quantity">The quantity.</param>
        void Remove(Product product, int quantity);
    }
}
